import React from 'react';
import { Layout, Menu, Icon } from 'antd';

const { SubMenu } = Menu;
const { Sider } = Layout;


export default class SiderView extends React.Component {


    $renderItem(db) {
        let res = [];
        for(var k in db) {
            const list = db[k];
            const items = list.map((item, i) => {
                return <Menu.Item key="{i}">{item.page}</Menu.Item>
            });
            res.push((
                <SubMenu key={k} title={k}>
                    {items}
                </SubMenu>
            ))
        }
        console.log(res)
        return res;
    }

    render() {

        const menuItems = this.$renderItem(this.props.db);
        

        return (
                <Sider width={200} style={{ background: '#fff' }}>
                <Menu
                    mode="inline"
                    defaultSelectedKeys={['1']}
                    defaultOpenKeys={['sub1']}
                    style={{ height: '100%' }}
                >
                    {menuItems}

                
                </Menu>
            </Sider>
        )
    }
}