import React from 'react';
import { Layout, Menu, Row, Col } from 'antd';

const { Header} = Layout;

import {
  BrowserRouter as Router,
  Route,
  HashRouter,
  Redirect,
  Link
} from 'react-router-dom';


export default class HeaderView extends React.Component {


    render() {
        const {db} = this.props;
        const nav = db.nav;

        const menuItems = nav.map((item, i) => {
            if (item.http) {
               return <Menu.Item key={i}><a href={item.http} target='__blank'>{item.label}</a></Menu.Item>
            } else {
                <Menu.Item key={i}> <Link to={item.md} >{item.label}</Link></Menu.Item>
            }
        });

        return (
            <div>
                <Row>
                    <Col span={6}>
                        <div  style={{color:"#fff"}}>{db.config.title}</div>
                    </Col>
                    <Col span={18}>
                        <Menu
                            theme="dark"
                            mode="horizontal"
                            defaultSelectedKeys={['2']}
                            style={{ lineHeight: '64px' }}
                        >
                            <Menu.Item key="1">nav 1</Menu.Item>
                            <Menu.Item key="2">nav 2</Menu.Item>
                            <Menu.Item key="3">nav 3</Menu.Item>
                        </Menu>
                    </Col>
                </Row>
              
                
            </div>
        )
    }
}