var fs = require('fs');
var path = require('path');
var walk = require('walk');
var sh = require('child_process').execSync;
var chalk = require('chalk');
var babel = require('babel-core');

module.exports = function (entry, out) {

    var p = new Promise(function (resolve, reject) {
        var walker = walk.walk(entry);

        walker.on('file', function (root, fileStats, next) {
            var name = fileStats.name;
            var ext = path.extname(name);
            var file = path.resolve('', root + '/' + name);

            if (ext === '.js') {
                var res = babel.transformFileSync(file);
                fs.writeFileSync(file, res.code);
            }

            next();
        });

        walker.on('end', function () {
            console.log(chalk.green('babel-执行完毕！！！'));
            resolve();
        });

        walker.on('error', function (e) {
            console.log(e);
            reject(e);
        });
    });

    return p;
};
;

var _temp = function () {
    if (typeof __REACT_HOT_LOADER__ === 'undefined') {
        return;
    }

    __REACT_HOT_LOADER__.register(sh, 'sh', 'src/babelFiles.js');
}();

;