/**
 * @file start commander, entry file
 * @author zhangpeng53
 */

"use strict";

var _this = this;

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

require("babel-core/register");
require('babel-polyfill');

var wpconfig = require('../webpack.config');
var webpack = require('webpack');
var walkmd = require('./walkmd');
var sh = require('child_process').execSync;
var path = require('path');
var fs = require('fs');
var parseNav = require('./parseNav');
var babelFiles = require('./babelFiles');

var node_modules = path.resolve(__dirname, '../node_modules');
var wpconfigPath = path.resolve(__dirname, '../webpack.config.js');

function parseWPConfig(config, isProduction) {
    var res = wpconfig(isProduction);
    if (config.setWebpackConfig) {
        res = config.setWebpackConfig(res);
    }
    return res;
}

function before(config) {

    var src = void 0;
    var dist = path.resolve(__dirname, '../theme');

    // 拷贝主题
    // 如果是默认主题则使用theme_default
    if (!config.theme || config.theme == 'default') {
        src = path.resolve(__dirname, '../theme_default');
    } else {
        src = path.resolve(process.cwd(), config.theme);
    }
    sh("rm -rf " + dist);
    sh("cp -R " + src + " " + dist);
    config.theme = dist;

    //拷贝静态资源
    var www = path.resolve(__dirname, '../www');
    sh("rm -rf " + www);
    sh("mv " + path.join(dist, './static') + " " + www);

    //创建临时文件夹
    var tmp = config.theme + '/tmp';
    if (fs.existsSync(tmp)) sh("rm -rf " + tmp);
    fs.mkdirSync(tmp);

    // 处理导航数据
    parseNav(config);
};

exports.dev = function () {
    var _ref = _asyncToGenerator(regeneratorRuntime.mark(function _callee(config) {
        var server, wpConfig;
        return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
                switch (_context.prev = _context.next) {
                    case 0:
                        before(config);
                        _context.next = 3;
                        return babelFiles(config.theme, config.theme);

                    case 3:
                        _context.next = 5;
                        return walkmd(config);

                    case 5:
                        server = require('./server');
                        wpConfig = parseWPConfig(config, false);

                        server(config, wpConfig);

                    case 8:
                    case "end":
                        return _context.stop();
                }
            }
        }, _callee, _this);
    }));

    return function (_x) {
        return _ref.apply(this, arguments);
    };
}();

exports.build = function (config) {
    before(config);

    walkmd(config, function () {
        var site = path.resolve(process.cwd(), 'site');
        sh("rm -rf " + site);

        var compiler = webpack(parseWPConfig(config, true));
        compiler.run(function (err, stats) {
            // console.log(stats);
        });
    });
};
;

var _temp = function () {
    if (typeof __REACT_HOT_LOADER__ === 'undefined') {
        return;
    }

    __REACT_HOT_LOADER__.register(sh, "sh", "src/cherry.js");

    __REACT_HOT_LOADER__.register(node_modules, "node_modules", "src/cherry.js");

    __REACT_HOT_LOADER__.register(wpconfigPath, "wpconfigPath", "src/cherry.js");

    __REACT_HOT_LOADER__.register(parseWPConfig, "parseWPConfig", "src/cherry.js");

    __REACT_HOT_LOADER__.register(before, "before", "src/cherry.js");
}();

;