/**
 * @file devserver
 * @author zhangpeng53
 */

var path = require('path');
var express = require('express');
var webpack = require('webpack');

module.exports = function (cherryConfig, wpConfig) {

    var sc = cherryConfig.server;

    var app = express();

    var compiler = webpack(wpConfig);

    app.use(require('webpack-dev-middleware')(compiler, {
        noInfo: true,
        publicPath: wpConfig.output.publicPath
    }));

    app.use(require('webpack-hot-middleware')(compiler, {
        reload: true
    }));

    app.use(express.static(path.resolve(__dirname, '../www')));

    //add middleware
    if (sc.middleware && sc.middleware.length) {
        sc.middleware.forEach(function (item) {
            app.use(item);
        });
    }

    app.get('*', function (req, res) {
        // res.sendFile(path.join(__dirname, 'dev/index.html'));
        res.send('404！！！');
    });

    var port = sc.port || 9000;
    app.listen(port, function (err) {
        if (err) {
            console.log(err);
            return;
        }
        console.log('Listening at http://localhost:' + port);
    });
};
;

var _temp = function () {
    if (typeof __REACT_HOT_LOADER__ === 'undefined') {
        return;
    }
}();

;